Bug 987433 - Review Request: libcomps - alternative for yum.comps
Review Request: libcomps - alternative for yum.comps
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ales Kozumplik
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2013-07-23 07:30 EDT by Jindrich Luza
Modified: 2014-09-30 19:41 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2013-08-14 06:32:04 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
akozumpl: fedora‑review+

Attachments (Terms of Use)

  None (edit)
Description Jindrich Luza 2013-07-23 07:30:06 EDT
Spec URL: https://docs.google.com/file/d/0B1LZtQy9lCKnQklKWFY5angyQmM/edit?usp=sharing
SRPM URL: https://docs.google.com/file/d/0B1LZtQy9lCKnTHNLTzRUZzk1MkE/edit?usp=sharing

Description: Libcomps is alternative for yum.comps library, written in C
Fedora Account System Username:jluza
Comment 1 Ales Kozumplik 2013-07-26 04:22:37 EDT
automated output seems fine:

===== MUST items =====

[ ]: Package does not contain kernel modules.
[ ]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

[ ]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
[ ]: %build honors applicable compiler flags or justifies otherwise.
[ ]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
     Note: Using prebuilt rpms.
[ ]: Package contains no bundled libraries without FPC exception.
[ ]: Changelog in prescribed format.
[ ]: Sources contain only permissible code or content.
[ ]: Package contains desktop file if it is a GUI application.
[ ]: Development files must be in a -devel package
[ ]: Package requires other packages for directories it uses.
[ ]: Package uses nothing in %doc for runtime.
[ ]: Package is not known to require ExcludeArch.
[ ]: Package complies to the Packaging Guidelines
[ ]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL", "Unknown or generated". 10 files have unknown license. Detailed
     output of licensecheck in /home/akozumpl/Downloads/review-
[ ]: Package consistently uses macro is (instead of hard-coded directory
[ ]: Package is named according to the Package Naming Guidelines.
[ ]: Package does not generate any conflict.
[ ]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Package must own all directories that it creates.
[ ]: Package does not own files or directories owned by other packages.
[ ]: Requires correct, justified where necessary.
[ ]: Spec file is legible and written in American English.
[ ]: Package contains systemd file(s) if in need.
[ ]: Large documentation must go in a -doc subpackage.
[ ]: Packages must not store files under /srv, /opt or /usr/local
     Note: Cannot unpack rpms (using --prebuilt?)
[ ]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
     Note: Using prebuilt packages
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
[x]: File names are valid UTF-8.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.

===== SHOULD items =====

[!]: Reviewer should test that the package builds in mock.
[ ]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Scriptlets must be sane, if used.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.
Comment 2 Ales Kozumplik 2013-07-26 04:22:58 EDT
the package builds fine.
Comment 3 Ales Kozumplik 2013-07-26 04:23:44 EDT
rpmlint on the spec gives warnings:

[akozumpl@localhost ~/Downloads]$ rpmlint libcomps.spec
libcomps.spec:5: W: macro-in-comment %global
libcomps.spec:119: W: macro-in-comment %doc
libcomps.spec:133: W: macro-in-comment %doc
libcomps.spec:140: W: macro-in-comment %doc
0 packages and 1 specfiles checked; 0 errors, 4 warnings.

please remove these comments from the spec file.
Comment 4 Christopher Meng 2013-07-26 04:27:04 EDT
Remove rm -rf %{buildroot} in install section.


README.md COPYING can be put into main package, -doc subpackage should only contains some real documents.
Comment 5 Ales Kozumplik 2013-07-26 04:30:18 EDT
This is a nit, but can you please change the description from:
"Alternative for yum.comps written in C"

It shouldn't reference yum.comps as that's about to disappear soon and many people are not even aware how comps are parsed. Just say what the lib is capable of in general.
Comment 6 Ales Kozumplik 2013-07-26 04:43:50 EDT
Outcome of nontrivial high-quality review is that the package NEEDSWORK for now, on the issues mentioned in comments 3 to 5.
Comment 7 Michael Schwendt 2013-07-29 06:23:31 EDT
> %files
> %{_libdir}/libcomps.so.*
> %exclude %{_libdir}/python*

Uh? The %exclude statement here is useless, because no other line in this %files section includes what you want to be excluded.

> %files devel
> %{_libdir}/libcomps.so
> %exclude %{_libdir}/python*
> %{_includedir}/*

Same here.
Comment 9 Ales Kozumplik 2013-07-30 08:17:47 EDT
this is much better, the only remaining thing I see is the conditional compilation for python2/python3. why not just drop the globals determining this and always build both packages in Fedora?
Comment 10 Ales Kozumplik 2013-07-30 08:18:43 EDT
(In reply to Ales Kozumplik from comment #9)
> this is much better, the only remaining thing I see is the conditional
> compilation for python2/python3. why not just drop the globals determining
> this and always build both packages in Fedora?

hmm, formulated as a question, though what I mean is: drop the globals and simplify the spec and then we're good to go.
Comment 13 Ales Kozumplik 2013-07-30 09:36:09 EDT
Comment 14 Jindrich Luza 2013-08-02 06:58:00 EDT
New Package SCM Request
Package Name: libcomps
Short Description: Comps XML file manipulation library
Owners: jluza
Branches: f18 f19 el6
Comment 15 Gwyn Ciesla 2013-08-02 08:00:23 EDT
"jluza" is not in the packager group.
Comment 16 Dan Horák 2013-08-02 09:11:33 EDT
I'll sponsor Jindrich and here are my notes that need to be addressed
- drop the %global name as it's redundant, the same variable is provided by the Name tag, and use the "commit" variable for Source0 URL
- the source archive is actually a ZIP file although is called tar.gz
- build fails on arm (http://koji.fedoraproject.org/koji/taskinfo?taskID=5691667)
- why there is versioned BR for cmake? There 2.8.x in Fedora for a long time.
- drop the hardcoded Requires: python[23], they will added by rpm-build automagically in form "python(abi) = major.minor"
Comment 17 Dan Horák 2013-08-02 09:15:24 EDT
for EPEL-6 you will need to BR: cmake28 as RHEL-6 carries cmake in version 2.6
Comment 18 Dan Horák 2013-08-03 02:53:59 EDT
and the doc subpackage should be built as noarch (via BuildArch: noarch), eventually with the doxygen config updated so it doesn't include timestamps into the generated content (usually footers)
Comment 20 Ales Kozumplik 2013-08-07 07:00:46 EDT
Dan, can you please sponsor Jindrich now that he removed all the issues?
Comment 21 Dan Horák 2013-08-07 07:14:20 EDT
looks good now, the last thing required is to drop the %{_isa} suffix in the Requires for the doc subpackage, it makes the noarch subpackage different between arches (http://koji.fedoraproject.org/koji/taskinfo?taskID=5783319), please fix before importing to git

package is APPROVED, I'm going to sponsor Jindrich now
Comment 22 Jindrich Luza 2013-08-08 06:39:59 EDT
New Package SCM Request
Package Name: libcomps
Short Description: Comps XML file manipulation library
Owners: jluza
Branches: f18 f19 el6
Comment 23 Gwyn Ciesla 2013-08-08 08:20:35 EDT
Git done (by process-git-requests).
Comment 24 Jindrich Luza 2014-07-11 08:19:14 EDT
Package Change Request
Package Name: libcomps 
New Branches: epel7
Owners: jluza
Comment 25 Gwyn Ciesla 2014-07-11 09:23:47 EDT
Branch exists.

Note You need to log in before you can comment on or make changes to this bug.